import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  ECSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../ECSClient";
import {
  ListServicesByNamespaceRequest,
  ListServicesByNamespaceResponse,
} from "../models/models_0";
export interface ListServicesByNamespaceCommandInput
  extends ListServicesByNamespaceRequest {}
export interface ListServicesByNamespaceCommandOutput
  extends ListServicesByNamespaceResponse,
    __MetadataBearer {}
export declare class ListServicesByNamespaceCommand extends $Command<
  ListServicesByNamespaceCommandInput,
  ListServicesByNamespaceCommandOutput,
  ECSClientResolvedConfig
> {
  readonly input: ListServicesByNamespaceCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListServicesByNamespaceCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: ECSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListServicesByNamespaceCommandInput,
    ListServicesByNamespaceCommandOutput
  >;
  private serialize;
  private deserialize;
}
